package com.cultural.heritage.service.good;

import com.baomidou.mybatisplus.extension.service.IService;
import com.cultural.heritage.model.dto.cartService.CartExperienceAddRequest;
import com.cultural.heritage.model.dto.cartService.CartExperienceOrderItemAddRequest;
import com.cultural.heritage.model.entity.CartExperience;
import com.cultural.heritage.model.vo.cartService.CartExperienceVO;
import jakarta.servlet.http.HttpServletRequest;

import java.util.List;

public interface CartExperienceService extends IService<CartExperience> {


    /**
     * 更新购物车的商品属性
     */
    boolean updateCartGoodAttribute(CartExperienceAddRequest cartExperienceAddRequest, HttpServletRequest request);


    /**
     * 封装用户购物车中的商品信息
     */
    List<CartExperienceVO> transformToCartRecordVOList(List<CartExperience> cartExperienceList);


    /**
     * 校验购物车中的商品信息
     */
    void validCart(CartExperience cartExperience, boolean update);



    /**
     * 在提交订单页校验购物车商品项的准确性
     */
    boolean validIsConsistent(List<CartExperienceOrderItemAddRequest> cartExperienceOrderItemAddRequestList);



    /**
     * 找出存在问题的购物车id列表
     */
    List<Long> getInvalidCartIds(List<CartExperience> cartExperienceList);

}
